-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Speech To Text
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Charts - Export Custom Markup
The DevExpress.viz.exportFromMarkup(markup, options) method allows you to export SVG content, including SVG-based DevExtreme components, to an image or document.
The markup parameter accepts valid SVG markup (see the prepareMarkup() function in the code). To get the markup of a component, call its svg() method. The options parameter accepts an object whose fields configure export properties. In this demo, we specify the width, height, format, and svgToCanvas fields. Refer to the method description for more information on these and other available fields.
Backend API
$(() => {
const chart = $('#chart').dxChart({
palette: 'Violet',
dataSource,
commonSeriesSettings: {
barPadding: 0.3,
argumentField: 'state',
type: 'bar',
},
series: [
{
valueField: 'year1990',
name: '1990',
},
{
valueField: 'year2000',
name: '2000',
},
{
valueField: 'year2010',
name: '2010',
},
{
valueField: 'year2016',
name: '2016',
},
{
valueField: 'year2017',
name: '2017',
},
],
legend: {
verticalAlignment: 'bottom',
horizontalAlignment: 'center',
},
title: {
text: 'Oil Production',
subtitle: {
text: '(in millions tonnes)',
},
},
}).dxChart('instance');
$('#export').dxButton({
icon: 'export',
text: 'Export',
type: 'default',
width: 145,
onClick() {
DevExpress.viz.exportFromMarkup(prepareMarkup(), {
width: 820,
height: 420,
margin: 0,
format: 'png',
svgToCanvas(svg, canvas) {
const deferred = $.Deferred();
canvas.getContext('2d')
.drawSvg(new XMLSerializer().serializeToString(svg), 0, 0, null, null, {
renderCallback: deferred.resolve,
});
return deferred.promise();
},
});
},
});
function prepareMarkup() {
const svg = document.createElementNS('http://www.w3.org/2000/svg', 'svg');
svg.setAttribute('xmlns', 'http://www.w3.org/2000/svg');
svg.setAttribute('xmlns:xlink', 'http://www.w3.org/1999/xlink');
svg.setAttribute('version', '1.1');
svg.setAttribute('width', '820px');
svg.setAttribute('height', '420px');
svg.innerHTML = document.getElementById('custom_markup_container').innerHTML;
const group = document.createElementNS('http://www.w3.org/2000/svg', 'g');
group.setAttribute('transform', 'translate(305,12)');
group.innerHTML = chart.svg();
svg.appendChild(group);
return svg;
}
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.6/css/dx.light.css" />
<script src="js/dx.all.js?v=25.1.6"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
<script src="https://cdn.jsdelivr.net/npm/canvg/dist/browser/canvg.min.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="chart-demo">
<div class="chart_environment">
<div id="custom_markup_container">
<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1" width="820px" height="420px">
<path d="M 13 407 L 128 407 L 232 39 L 13 39" fill="#6D39C3"></path>
<path d="M 46 381 L 161 381 L 265 13 L 46 13" opacity="0.5" fill="#6D39C3"></path>
<text transform="translate(30,89)" style="fill: #ffffff; font-family: 'Segoe UI', 'Helvetica Neue', 'Trebuchet MS', Verdana, sans-serif; font-size: 36px; font-weight: bold">
<tspan x="0" y="0">Export</tspan>
<tspan x="0" y="38">Custom</tspan>
<tspan x="0" y="76">Markup</tspan>
</text>
<text transform="translate(32,199)" style="opacity: 0.8; fill: #ffffff; font-family: 'Segoe UI', 'Helvetica Neue', 'Trebuchet MS', Verdana, sans-serif; font-size: 14px">
<tspan x="0" y="0">Export a chart with</tspan>
<tspan x="0" y="19.2">custom elements</tspan>
</text>
<path opacity="0.8" d="M 0 0 L 820 0 L 820 420 L 0 420 L 0 0" stroke="#999999" stroke-width="1" stroke-linecap="butt" fill="none" stroke-linejoin="miter"></path>
</svg>
</div>
<div id="chart"></div>
</div>
<div class="controls-pane">
<div id="export"></div>
</div>
</div>
</div>
</body>
</html>
#chart-demo {
height: 460px;
}
#chart {
position: absolute;
top: 12px;
right: 35px;
width: 480px;
height: 347px;
}
.chart_environment {
width: 820px;
position: relative;
margin: 0 auto;
}
.controls-pane {
text-align: center;
}
const dataSource = [{
state: 'Saudi Arabia',
year1990: 319.6,
year2000: 408.4,
year2010: 407,
year2016: 523,
year2017: 496.6,
}, {
state: 'USA',
year1990: 362.8,
year2000: 287.9,
year2010: 270.2,
year2016: 438,
year2017: 461.4,
}, {
state: 'China',
year1990: 138.3,
year2000: 163,
year2010: 203,
year2016: 199.7,
year2017: 191.5,
}];

Backend API
import React, { useCallback, useRef } from 'react';
import {
Chart,
CommonSeriesSettings,
Series,
Legend,
Title,
Subtitle,
} from 'devextreme-react/chart';
import type { ChartRef } from 'devextreme-react/chart';
import { Button } from 'devextreme-react/button';
import { exportFromMarkup } from 'devextreme/viz/export';
import { Canvg } from 'canvg';
import { dataSource } from './data.ts';
import Form from './Form.tsx';
const barPadding = 0.3;
const prepareMarkup = (chartSVG: string, markup: string) => {
const svg = document.createElementNS('http://www.w3.org/2000/svg', 'svg');
svg.setAttribute('xmlns', 'http://www.w3.org/2000/svg');
svg.setAttribute('xmlns:xlink', 'http://www.w3.org/1999/xlink');
svg.setAttribute('version', '1.1');
svg.setAttribute('width', '820px');
svg.setAttribute('height', '420px');
svg.innerHTML = markup;
const group = document.createElementNS('http://www.w3.org/2000/svg', 'g');
group.setAttribute('transform', 'translate(305,12)');
group.innerHTML = chartSVG;
svg.appendChild(group);
return svg;
};
function App() {
const childRef = useRef<HTMLDivElement>(null);
const chartRef = useRef<ChartRef>(null);
const onClick = useCallback(() => {
exportFromMarkup(
prepareMarkup(chartRef.current?.instance().svg() ?? '',
childRef.current?.innerHTML ?? ''), {
width: 820,
height: 420,
margin: 0,
format: 'png',
svgToCanvas(svg: Node, canvas: HTMLCanvasElement) {
return new Promise((resolve): void => {
const ctx = canvas.getContext('2d');
if (!ctx) {
resolve(() => {});
return;
}
const v = Canvg.fromString(
ctx,
new XMLSerializer().serializeToString(svg)
);
resolve(v.render());
});
},
},
);
}, []);
return (
<div id="chart-demo">
<div className="chart_environment">
<Form ref={childRef} />
<Chart
ref={chartRef}
id="chart"
dataSource={dataSource}
palette="Violet"
>
<CommonSeriesSettings barPadding={barPadding} argumentField="state" type="bar" />
<Series valueField="year2000" name="2000" />
<Series valueField="year2010" name="2010" />
<Series valueField="year2020" name="2020" />
<Series valueField="year2021" name="2021" />
<Series valueField="year2022" name="2022" />
<Legend verticalAlignment="bottom" horizontalAlignment="center" />
<Title text="Oil Production">
<Subtitle text="(in millions tonnes)" />
</Title>
</Chart>
</div>
<div className="controls-pane">
<Button
id="export"
width={145}
icon="export"
text="Export"
type="default"
onClick={onClick}
/>
</div>
</div>
);
}
export default App;
import React, { useCallback, useRef } from 'react';
import {
Chart,
CommonSeriesSettings,
Series,
Legend,
Title,
Subtitle,
} from 'devextreme-react/chart';
import { Button } from 'devextreme-react/button';
import { exportFromMarkup } from 'devextreme/viz/export';
import { Canvg } from 'canvg';
import { dataSource } from './data.js';
import Form from './Form.js';
const barPadding = 0.3;
const prepareMarkup = (chartSVG, markup) => {
const svg = document.createElementNS('http://www.w3.org/2000/svg', 'svg');
svg.setAttribute('xmlns', 'http://www.w3.org/2000/svg');
svg.setAttribute('xmlns:xlink', 'http://www.w3.org/1999/xlink');
svg.setAttribute('version', '1.1');
svg.setAttribute('width', '820px');
svg.setAttribute('height', '420px');
svg.innerHTML = markup;
const group = document.createElementNS('http://www.w3.org/2000/svg', 'g');
group.setAttribute('transform', 'translate(305,12)');
group.innerHTML = chartSVG;
svg.appendChild(group);
return svg;
};
function App() {
const childRef = useRef(null);
const chartRef = useRef(null);
const onClick = useCallback(() => {
exportFromMarkup(
prepareMarkup(chartRef.current?.instance().svg() ?? '', childRef.current?.innerHTML ?? ''),
{
width: 820,
height: 420,
margin: 0,
format: 'png',
svgToCanvas(svg, canvas) {
return new Promise((resolve) => {
const ctx = canvas.getContext('2d');
if (!ctx) {
resolve(() => {});
return;
}
const v = Canvg.fromString(ctx, new XMLSerializer().serializeToString(svg));
resolve(v.render());
});
},
},
);
}, []);
return (
<div id="chart-demo">
<div className="chart_environment">
<Form ref={childRef} />
<Chart
ref={chartRef}
id="chart"
dataSource={dataSource}
palette="Violet"
>
<CommonSeriesSettings
barPadding={barPadding}
argumentField="state"
type="bar"
/>
<Series
valueField="year2000"
name="2000"
/>
<Series
valueField="year2010"
name="2010"
/>
<Series
valueField="year2020"
name="2020"
/>
<Series
valueField="year2021"
name="2021"
/>
<Series
valueField="year2022"
name="2022"
/>
<Legend
verticalAlignment="bottom"
horizontalAlignment="center"
/>
<Title text="Oil Production">
<Subtitle text="(in millions tonnes)" />
</Title>
</Chart>
</div>
<div className="controls-pane">
<Button
id="export"
width={145}
icon="export"
text="Export"
type="default"
onClick={onClick}
/>
</div>
</div>
);
}
export default App;
import React from 'react';
const fontFamily = "'Segoe UI', 'Helvetica Neue', 'Trebuchet MS', Verdana, sans-serif";
const Form = React.forwardRef<HTMLDivElement>((_, ref) => (
<div id="custom_markup_container" ref={ref}>
<svg width="820px" height="420px">
<path opacity="1" d="M 0 0 L 820 0 L 820 420 L 0 420 L 0 0" stroke="#999999" strokeWidth="1"
strokeLinecap="butt" fill="white" strokeLinejoin="miter"></path>
<path d="M 13 407 L 128 407 L 232 39 L 13 39" fill="#6D39C3"></path>
<path d="M 46 381 L 161 381 L 265 13 L 46 13" opacity="0.5" fill="#6D39C3"></path>
<text transform="translate(30,89)"
style={{
fill: '#FFFFFF', fontFamily, fontSize: 36, fontWeight: 'bold',
}}>
<tspan x="0" y="0">Export </tspan>
<tspan x="0" y="38">Custom</tspan>
<tspan x="0" y="76">Markup</tspan>
</text>
<text transform="translate(32,199)"
style={{
opacity: 0.8, fill: '#FFFFFF', fontFamily, fontSize: 14,
}}>
<tspan x="0" y="0">Export a chart with</tspan>
<tspan x="0" y="19.2">custom elements</tspan>
</text>
</svg>
</div>
));
Form.displayName = 'Form';
export default Form;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export const dataSource = [{
state: 'Saudi Arabia',
year2000: 408,
year2010: 407,
year2020: 498,
year2021: 515,
year2022: 602,
}, {
state: 'USA',
year2000: 288,
year2010: 270,
year2020: 713,
year2021: 711,
year2022: 762,
}, {
state: 'Mexico',
year2000: 150,
year2010: 146,
year2020: 101,
year2021: 97,
year2022: 95,
}];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'canvg': 'externals:canvg.bundle.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.25/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.67/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"canvg": {
"version": "4.0.3"
}
};
import React from 'react';
const fontFamily = "'Segoe UI', 'Helvetica Neue', 'Trebuchet MS', Verdana, sans-serif";
const Form = React.forwardRef((_, ref) => (
<div
id="custom_markup_container"
ref={ref}
>
<svg
width="820px"
height="420px"
>
<path
opacity="1"
d="M 0 0 L 820 0 L 820 420 L 0 420 L 0 0"
stroke="#999999"
strokeWidth="1"
strokeLinecap="butt"
fill="white"
strokeLinejoin="miter"
></path>
<path
d="M 13 407 L 128 407 L 232 39 L 13 39"
fill="#6D39C3"
></path>
<path
d="M 46 381 L 161 381 L 265 13 L 46 13"
opacity="0.5"
fill="#6D39C3"
></path>
<text
transform="translate(30,89)"
style={{
fill: '#FFFFFF',
fontFamily,
fontSize: 36,
fontWeight: 'bold',
}}
>
<tspan
x="0"
y="0"
>
Export{' '}
</tspan>
<tspan
x="0"
y="38"
>
Custom
</tspan>
<tspan
x="0"
y="76"
>
Markup
</tspan>
</text>
<text
transform="translate(32,199)"
style={{
opacity: 0.8,
fill: '#FFFFFF',
fontFamily,
fontSize: 14,
}}
>
<tspan
x="0"
y="0"
>
Export a chart with
</tspan>
<tspan
x="0"
y="19.2"
>
custom elements
</tspan>
</text>
</svg>
</div>
));
Form.displayName = 'Form';
export default Form;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const dataSource = [
{
state: 'Saudi Arabia',
year2000: 408,
year2010: 407,
year2020: 498,
year2021: 515,
year2022: 602,
},
{
state: 'USA',
year2000: 288,
year2010: 270,
year2020: 713,
year2021: 711,
year2022: 762,
},
{
state: 'Mexico',
year2000: 150,
year2010: 146,
year2020: 101,
year2021: 97,
year2022: 95,
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#chart-demo {
height: 460px;
}
#chart {
position: absolute;
top: 12px;
right: 35px;
width: 480px;
height: 347px;
}
.chart_environment {
width: 820px;
position: relative;
margin: 0 auto;
}
.controls-pane {
text-align: center;
}

Backend API
<div class="chart-environment">
<div id="custom-markup-container">
<svg version="1.1" width="820px" height="420px">
<path
d="M 0 0 L 820 0 L 820 420 L 0 420 L 0 0"
stroke="#999999"
stroke-width="1"
stroke-linecap="butt"
fill="white"
stroke-linejoin="miter"
></path>
<path d="M 13 407 L 128 407 L 232 39 L 13 39" fill="#6D39C3"></path>
<path
d="M 46 381 L 161 381 L 265 13 L 46 13"
opacity="0.5"
fill="#6D39C3"
></path>
<text
transform="translate(30,89)"
class="custom-markup-text custom-markup-text-title"
>
<tspan x="0" y="0">Export</tspan>
<tspan x="0" y="38">Custom</tspan>
<tspan x="0" y="76">Markup</tspan>
</text>
<text
transform="translate(32,199)"
class="custom-markup-text custom-markup-text-subtitle"
>
<tspan x="0" y="0">Export a chart with</tspan>
<tspan x="0" y="19.2">custom elements</tspan>
</text>
</svg>
</div>
<dx-chart id="chart" [dataSource]="oilProductionData" palette="Violet">
<dxi-chart-series valueField="year2000" name="2000"></dxi-chart-series>
<dxi-chart-series valueField="year2010" name="2010"></dxi-chart-series>
<dxi-chart-series valueField="year2020" name="2020"></dxi-chart-series>
<dxi-chart-series valueField="year2021" name="2021"></dxi-chart-series>
<dxi-chart-series valueField="year2022" name="2022"></dxi-chart-series>
<dxo-chart-common-series-settings
argumentField="state"
type="bar"
[barPadding]="0.3"
>
</dxo-chart-common-series-settings>
<dxo-chart-legend verticalAlignment="bottom" horizontalAlignment="center">
</dxo-chart-legend>
<dxo-chart-title text="Oil Production">
<dxo-chart-subtitle text="(in millions tonnes)"></dxo-chart-subtitle>
</dxo-chart-title>
</dx-chart>
</div>
<div class="controls-pane">
<dx-button
icon="export"
text="Export"
type="default"
[width]="145"
(onClick)="export()"
>
</dx-button>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, ViewChild, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxChartModule, DxChartComponent, DxButtonModule } from 'devextreme-angular';
import { exportFromMarkup } from 'devextreme/viz/export';
import { Canvg } from 'canvg';
import { Service, OilProductionDataItem } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
providers: [Service],
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxChartModule,
DxButtonModule,
],
})
export class AppComponent {
@ViewChild(DxChartComponent, { static: false }) chart: DxChartComponent;
oilProductionData: OilProductionDataItem[];
constructor(service: Service) {
this.oilProductionData = service.getOilProductionData();
}
export() {
exportFromMarkup(this.prepareMarkup(), {
width: 820,
height: 420,
margin: 0,
format: 'png',
svgToCanvas(svg, canvas) {
return new Promise((resolve) => {
const v = Canvg.fromString(
canvas.getContext('2d'),
new XMLSerializer().serializeToString(svg)
);
resolve(v.render());
});
},
});
}
prepareMarkup() {
const sourceContainer = document.getElementById('custom-markup-container');
const sourceElements = sourceContainer.querySelectorAll('*');
const svg = document.createElementNS('http://www.w3.org/2000/svg', 'svg');
svg.setAttribute('xmlns', 'http://www.w3.org/2000/svg');
svg.setAttribute('xmlns:xlink', 'http://www.w3.org/1999/xlink');
svg.setAttribute('version', '1.1');
svg.setAttribute('width', '820px');
svg.setAttribute('height', '420px');
const clonedContainer = sourceContainer.cloneNode(true) as HTMLElement;
const clonedElements = clonedContainer.querySelectorAll('*');
clonedElements.forEach((clonedEl, index) => {
const sourceEl = sourceElements[index] as HTMLElement;
if (!sourceEl) return;
const computed = window.getComputedStyle(sourceEl);
['fill', 'font-family', 'font-size', 'font-weight', 'opacity', 'stroke', 'stroke-width'].forEach((prop) => {
const value = computed.getPropertyValue(prop)?.trim();
if (value && value !== 'auto' && value !== 'normal' && value !== 'initial') {
(clonedEl as SVGElement).setAttribute(prop, value);
}
});
});
svg.innerHTML = clonedContainer.innerHTML;
const group = document.createElementNS('http://www.w3.org/2000/svg', 'g');
group.setAttribute('transform', 'translate(305,12)');
group.innerHTML = this.chart.instance.svg();
svg.appendChild(group);
return svg;
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #chart {
position: absolute;
top: 12px;
right: 35px;
width: 480px;
height: 347px;
}
::ng-deep .chart-environment {
width: 820px;
position: relative;
margin: 0 auto;
}
::ng-deep .controls-pane {
text-align: center;
}
::ng-deep .custom-markup-text {
fill: #fff;
font-family: 'Segoe UI', 'Helvetica Neue', 'Trebuchet MS', Verdana, sans-serif;
}
::ng-deep .custom-markup-text-title {
font-size: 36px;
font-weight: bold;
}
::ng-deep .custom-markup-text-subtitle {
font-size: 14px;
opacity: 0.8;
}
import { Injectable } from '@angular/core';
export class OilProductionDataItem {
state: string;
year2000: number;
year2010: number;
year2020: number;
year2021: number;
year2022: number;
}
const oilProductionData: OilProductionDataItem[] = [{
state: 'Saudi Arabia',
year2000: 408,
year2010: 407,
year2020: 498,
year2021: 515,
year2022: 602,
}, {
state: 'USA',
year2000: 288,
year2010: 270,
year2020: 713,
year2021: 711,
year2022: 762,
}, {
state: 'Mexico',
year2000: 150,
year2010: 146,
year2020: 101,
year2021: 97,
year2022: 95,
}];
@Injectable()
export class Service {
getOilProductionData(): OilProductionDataItem[] {
return oilProductionData;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'canvg': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'canvg': 'externals:canvg.bundle.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"canvg": {
"version": "4.0.3"
},
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

Backend API
<template>
<div id="chart-demo">
<div class="chart_environment">
<Form ref="form"/>
<DxChart
id="chart"
ref="chart"
:data-source="dataSource"
palette="Violet"
>
<DxCommonSeriesSettings
:bar-padding="0.3"
argument-field="state"
type="bar"
/>
<DxSeries
value-field="year1990"
name="1990"
/>
<DxSeries
value-field="year2000"
name="2000"
/>
<DxSeries
value-field="year2010"
name="2010"
/>
<DxSeries
value-field="year2016"
name="2016"
/>
<DxSeries
value-field="year2017"
name="2017"
/>
<DxLegend
vertical-alignment="bottom"
horizontal-alignment="center"
/>
<DxTitle
text="Oil Production"
subtitle="(in millions tonnes)"
/>
</DxChart>
</div>
<div class="controls-pane">
<DxButton
id="export"
:width="145"
icon="export"
type="default"
text="Export"
@click="onClick()"
/>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import {
DxChart,
DxSeries,
DxCommonSeriesSettings,
DxLegend,
DxTitle,
} from 'devextreme-vue/chart';
import { exportFromMarkup } from 'devextreme/viz/export';
import DxButton from 'devextreme-vue/button';
import { Canvg } from 'canvg';
import { dataSource } from './data.ts';
import Form from './Form.vue';
const form = ref();
const chart = ref();
const prepareMarkup = (chartSVG: string, markup: string): SVGElement => {
const svg = document.createElementNS('http://www.w3.org/2000/svg', 'svg');
svg.setAttribute('xmlns', 'http://www.w3.org/2000/svg');
svg.setAttribute('xmlns:xlink', 'http://www.w3.org/1999/xlink');
svg.setAttribute('version', '1.1');
svg.setAttribute('width', '820px');
svg.setAttribute('height', '420px');
svg.innerHTML = markup;
const group = document.createElementNS('http://www.w3.org/2000/svg', 'g');
group.setAttribute('transform', 'translate(305,12)');
group.innerHTML = chartSVG;
svg.appendChild(group);
return svg;
};
function onClick(): void {
const chartSVG = chart.value.instance.svg();
const formContent = form.value.getMarkup();
exportFromMarkup(prepareMarkup(chartSVG, formContent), {
width: 820,
height: 420,
margin: 0,
format: 'png',
svgToCanvas(svg: SVGElement, canvas: HTMLCanvasElement) {
return new Promise((resolve) => {
const v = Canvg.fromString(
canvas.getContext("2d")!,
new XMLSerializer().serializeToString(svg)
);
resolve(v.render());
});
},
});
}
</script>
<style>
#chart-demo {
height: 460px;
}
#chart {
position: absolute;
top: 12px;
right: 35px;
width: 480px;
height: 347px;
}
.chart_environment {
width: 820px;
position: relative;
margin: 0 auto;
}
.controls-pane {
display: block;
text-align: center;
}
</style>
<!-- eslint-disable vue/max-len -->
<template>
<div class="custom_markup_container">
<svg
version="1.1"
width="820px"
height="420px"
>
<path
d="M 0 0 L 820 0 L 820 420 L 0 420 L 0 0"
stroke="#999999"
stroke-width="1"
stroke-linecap="butt"
fill="white"
stroke-linejoin="miter"
/>
<path
d="M 13 407 L 128 407 L 232 39 L 13 39"
fill="#6D39C3"
/>
<path
d="M 46 381 L 161 381 L 265 13 L 46 13"
opacity="0.5"
fill="#6D39C3"
/>
<text
transform="translate(30,89)"
style="fill: #fff; font-family: 'Segoe UI', 'Helvetica Neue', 'Trebuchet MS', Verdana, sans-serif; font-size: 36px; font-weight: bold;"
>
<tspan
x="0"
y="0"
>Export </tspan>
<tspan
x="0"
y="38"
>Custom</tspan>
<tspan
x="0"
y="76"
>Markup</tspan>
</text>
<text
transform="translate(32,199)"
style="opacity: 0.8; fill: #fff; font-family: 'Segoe UI', 'Helvetica Neue', 'Trebuchet MS', Verdana, sans-serif; font-size: 14px;"
>
<tspan
x="0"
y="0"
>Export a chart with</tspan>
<tspan
x="0"
y="19.2"
>custom elements</tspan>
</text>
</svg>
</div>
</template>
<script setup lang="ts">
defineExpose({
getMarkup(): string {
// @ts-ignore
return this.$el.innerHTML;
},
});
</script>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'canvg': 'externals:canvg.bundle.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.6/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"canvg": {
"version": "4.0.3"
}
};
export const dataSource = [{
state: 'Saudi Arabia',
year1990: 319.6,
year2000: 408.4,
year2010: 407,
year2016: 523,
year2017: 496.6,
}, {
state: 'USA',
year1990: 362.8,
year2000: 287.9,
year2010: 270.2,
year2016: 438,
year2017: 461.4,
}, {
state: 'China',
year1990: 138.3,
year2000: 163,
year2010: 203,
year2016: 199.7,
year2017: 191.5,
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.4.5/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>